<template>
  <div class="my-wrap">
    <div class="login">
      <h3>Register New User</h3>
      <form novalidate @submit.prevent="validateForm">
        <div class="msg-login" v-if="message!==''">{{message}}</div>
        <md-field :class="getValidationClass('rFn')">
          <label for="rFn">First Name</label>
          <md-input type="text" name="rFn" id="rFn" v-model="form.rFn" :disabled="sending"/>
          <span class="md-error" v-if="!$v.form.rFn.required">The First Name is required</span>
        </md-field>
        <md-field :class="getValidationClass('rLn')">
          <label for="rLn">Last Name</label>
          <md-input type="text" name="rLn" id="rLn" v-model="form.rLn" :disabled="sending"/>
          <span class="md-error" v-if="!$v.form.rLn.required">The Last Name is required</span>
        </md-field>
        <md-field :class="getValidationClass('rUsername')">
          <label for="rUsername">Username</label>
          <md-input
            type="text"
            name="rUsername"
            id="rUsername"
            v-model="form.rUsername"
            :disabled="sending"
          />
          <span class="md-error" v-if="!$v.form.rUsername.required">The Username is required</span>
        </md-field>
        <md-field :class="getValidationClass('rPassword')">
          <label for="rPassword">Password</label>
          <md-input
            type="password"
            name="rPassword"
            id="rPassword"
            v-model="form.rPassword"
            :disabled="sending"
          />
          <span class="md-error" v-if="!$v.form.rPassword.required">The Password is required</span>
        </md-field>
        <md-button type="submit" class="md-primary" :disabled="sending">Register</md-button>
      </form>
    </div>
  </div>
</template>
<script>
import { validationMixin } from "vuelidate";
import ApiService from "@/services/ApiService.js";
import { required } from "vuelidate/lib/validators";

export default {
  name: "RegisterComponent",
  mixins: [validationMixin],
  data: () => ({
    form: {
      rFn: null,
      rLn: null,
      rUsername: null,
      rPassword: null
    },
    sending: false,
    message: ""
  }),
  validations: {
    form: {
      rFn: {
        required
      },
      rLn: {
        required
      },
      rUsername: {
        required
      },
      rPassword: {
        required
      }
    }
  },
  methods: {
    getValidationClass(fieldName) {
      const field = this.$v.form[fieldName];

      if (field) {
        return {
          "md-invalid": field.$invalid && field.$dirty
        };
      }
    },
    clearForm() {
      this.$v.$reset();
      this.form.rFn = null;
      this.form.rLn = null;
      this.form.rUsername = null;
      this.form.rPassword = null;
    },
    async register() {
      this.sending = true;
      const payload = {
        fn: this.form.rFn,
        ln: this.form.rLn,
        username: this.form.rUsername.toLowerCase(),
        password: this.form.rPassword
      };

      let response;
      try {
        response = await ApiService.register(payload);
        if (response.status === 201) {
          this.message = "User has been created";
        }
      } catch (error) {
        this.message = error;
      }
      this.clearForm();
      this.sending = false;
    },
    validateForm() {
      this.$v.$touch();

      if (!this.$v.$invalid) {
        this.register();
      }
    }
  }
};
</script>

<style scoped>
.my-wrap {
  display: flex;
  justify-content: center;
  align-items: center;
  width: 100%;
  height: 100%;
}
.msg-login {
  margin: 10px;
  padding: 5px;
  border: 1px solid;
  border-radius: 5px;
  display: flex;
  color: #856404;
  background-color: #fff3cd;
  border-color: #ffeeba;
}
.md-card {
  width: 320px;
  /* margin: 4px; */
  -webkit-box-pack: center;
  display: inline-block;
  vertical-align: top;
}
.login {
  align-items: center;
  display: flex;
  flex-direction: column;
  display: flex;
  flex-direction: column;
  justify-content: center;
  width: 300px;
  height: fit-content;
}
.md-progress-bar {
  position: absolute;
  top: 0;
  right: 0;
  left: 0;
}
</style>